{******************************************************************************

 ANALOG DEVICES 
 EUROPEAN DSP APPLICATIONS
 
 versatile FLASH utility for embedded systems
  
 custom boot loader, starts module specified by pm[7]		   Ver: 1.00.0
 
	created     17-SEP-97 by hs
	last change 28-SEP-97 by hs

 ******************************************************************************
}
.module/ram/abs=0	flash_srv;

.const  BIAD	= 0x3fe1;
.const  BEAD	= 0x3fe2;
.const  BDMAC	= 0x3fe3;
.const  BWCOUNT	= 0x3fe4;

					{ Start of 32 word loader }
	i4 = 0x2000;
	pmovlay = 1;
	ar = pm(i4,m4);			{ read the DIP switch }
	pmovlay = 0;
	
	ar = px;			{ get the lowest eight bits }

					{ program table:
					  0 - user 1th 64k = 4 pages = 0x00000
					  1 - user 2nd 64k = 4 pages = 0x10000
					  2 - user 3rd 64k = 4 pages = 0x20000
					  :
					  7 - monitor unavailable to user
					}

	ar = tstbit 7 of ar;		{ test switch }
	if eq jump lab1;		{ offset 0x0 for user }
	ar = 0x1c00;			{ offset 0x70000 for monitor }
	jump lab2;
lab1:	ar = 0x0;
	
lab2:	ax0 = 96;			{ past the original boot }
	dm(BEAD) = ax0;
	ax0 = 32;			{ past the original boot }
	dm(BIAD) = ax0;

	dm(BDMAC) = ar;			{ set btype = 0, bcr = 0, 
						page = px, and bdir = 0 }
	ax0 = 135;			{ old: 81, new 135 }
	dm(BWCOUNT) = ax0;		{ size of byte loader code }
	ifc = 0x0008;			{ clears pending BDMA interrupt }
	nop;				{ 1 cycle latency in setting IFC }
	imask = 0x08;
	idle;				{ wait for BDMA transfer to finish }
	jump 32;			{ start of loader code is at 32 }
					
	nop;
	nop;
	
	nop;
	nop;
	nop;
	nop;
	
	rti;                      	{ BDMA interrupt vector }
	nop;
	nop;
	nop;

.endmod;